<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>CreateMode.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper</a> &gt; <span class="el_source">CreateMode.java</span></div><h1>CreateMode.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.zookeeper;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.apache.zookeeper.KeeperException;

/***
 *  CreateMode value determines how the znode is created on ZooKeeper.
 */
<span class="pc" id="L27">public enum CreateMode {</span>
    
    /**
     * The znode will not be automatically deleted upon client's disconnect.
     */
<span class="fc" id="L32">    PERSISTENT (0, false, false),</span>
    /**
    * The znode will not be automatically deleted upon client's disconnect,
    * and its name will be appended with a monotonically increasing number.
    */
<span class="fc" id="L37">    PERSISTENT_SEQUENTIAL (2, false, true),</span>
    /**
     * The znode will be deleted upon the client's disconnect.
     */
<span class="fc" id="L41">    EPHEMERAL (1, true, false),</span>
    /**
     * The znode will be deleted upon the client's disconnect, and its name
     * will be appended with a monotonically increasing number.
     */
<span class="fc" id="L46">    EPHEMERAL_SEQUENTIAL (3, true, true);</span>

<span class="fc" id="L48">    private static final Logger LOG = LoggerFactory.getLogger(CreateMode.class);</span>

    private boolean ephemeral;
    private boolean sequential;
    private int flag;

<span class="fc" id="L54">    CreateMode(int flag, boolean ephemeral, boolean sequential) {</span>
<span class="fc" id="L55">        this.flag = flag;</span>
<span class="fc" id="L56">        this.ephemeral = ephemeral;</span>
<span class="fc" id="L57">        this.sequential = sequential;</span>
<span class="fc" id="L58">    }</span>

    public boolean isEphemeral() { 
<span class="fc" id="L61">        return ephemeral;</span>
    }

    public boolean isSequential() { 
<span class="fc" id="L65">        return sequential;</span>
    }

    public int toFlag() {
<span class="fc" id="L69">        return flag;</span>
    }

    /**
     * Map an integer value to a CreateMode value
     */
    static public CreateMode fromFlag(int flag) throws KeeperException {
<span class="fc bfc" id="L76" title="All 5 branches covered.">        switch(flag) {</span>
<span class="fc" id="L77">        case 0: return CreateMode.PERSISTENT;</span>

<span class="fc" id="L79">        case 1: return CreateMode.EPHEMERAL;</span>

<span class="fc" id="L81">        case 2: return CreateMode.PERSISTENT_SEQUENTIAL;</span>

<span class="fc" id="L83">        case 3: return CreateMode.EPHEMERAL_SEQUENTIAL ;</span>

        default:
<span class="fc" id="L86">            String errMsg = &quot;Received an invalid flag value: &quot; + flag</span>
                    + &quot; to convert to a CreateMode&quot;;
<span class="fc" id="L88">            LOG.error(errMsg);</span>
<span class="fc" id="L89">            throw new KeeperException.BadArgumentsException(errMsg);</span>
        }
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>